When I catch an exception, how do I get the type, file, and line number? When I catch an exception, how do I get the type, file, and line number? python python

When I catch an exception, how do I get the type, file, and line number?


import sys, ostry:    raise NotImplementedError("No error")except Exception as e:    exc_type, exc_obj, exc_tb = sys.exc_info()    fname = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]    print(exc_type, fname, exc_tb.tb_lineno)


Simplest form that worked for me.

import tracebacktry:    print(4/0)except ZeroDivisionError:    print(traceback.format_exc())

Output

Traceback (most recent call last):  File "/path/to/file.py", line 51, in <module>    print(4/0)ZeroDivisionError: division by zeroProcess finished with exit code 0


Source (Py v2.7.3) for traceback.format_exception() and called/related functions helps greatly. Embarrassingly, I always forget to Read the Source. I only did so for this after searching for similar details in vain. A simple question, "How to recreate the same output as Python for an exception, with all the same details?" This would get anybody 90+% to whatever they're looking for. Frustrated, I came up with this example. I hope it helps others. (It sure helped me! ;-)

import sys, tracebacktraceback_template = '''Traceback (most recent call last):  File "%(filename)s", line %(lineno)s, in %(name)s%(type)s: %(message)s\n''' # Skipping the "actual line" item# Also note: we don't walk all the way through the frame stack in this example# see hg.python.org/cpython/file/8dffb76faacc/Lib/traceback.py#l280# (Imagine if the 1/0, below, were replaced by a call to test() which did 1/0.)try:    1/0except:    # http://docs.python.org/2/library/sys.html#sys.exc_info    exc_type, exc_value, exc_traceback = sys.exc_info() # most recent (if any) by default    '''    Reason this _can_ be bad: If an (unhandled) exception happens AFTER this,    or if we do not delete the labels on (not much) older versions of Py, the    reference we created can linger.    traceback.format_exc/print_exc do this very thing, BUT note this creates a    temp scope within the function.    '''    traceback_details = {                         'filename': exc_traceback.tb_frame.f_code.co_filename,                         'lineno'  : exc_traceback.tb_lineno,                         'name'    : exc_traceback.tb_frame.f_code.co_name,                         'type'    : exc_type.__name__,                         'message' : exc_value.message, # or see traceback._some_str()                        }    del(exc_type, exc_value, exc_traceback) # So we don't leave our local labels/objects dangling    # This still isn't "completely safe", though!    # "Best (recommended) practice: replace all exc_type, exc_value, exc_traceback    # with sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]    print    print traceback.format_exc()    print    print traceback_template % traceback_details    print

In specific answer to this query:

sys.exc_info()[0].__name__, os.path.basename(sys.exc_info()[2].tb_frame.f_code.co_filename), sys.exc_info()[2].tb_lineno


matomo